{ File   : LIBEXT.PAS
  Author : Deniz Oezmen
  Created: 2002-04-17
  Changed: 2005-08-26

  The Lost Files of Sherlock Holmes: The Case of The Serrated Scalpel LIB
  extractor.
}
program LIBExt;

type
  TFileEntry = record
                 Null1   : Byte; (* immer 0? *)
                 FileName: array[1..12] of Char;
                 Null2   : Byte; (* s.o.? *)
                 FileOffs: array[0..2] of Byte
               end;
var
  InFile: file;
  Header: record
            ID      : array[1..3] of Char;
            Unknown1,
            NrFiles : Byte
          end;

function OpenFile: Boolean;
begin
  if ParamCount > 0 then
  begin
    Assign(InFile, ParamStr(1));
    {$I-}
    Reset(InFile, 1);
    {$I+}
    OpenFile := IOResult = 0
  end
  else
    OpenFile := False
end;

function CheckFile: Boolean;
begin
  if FileSize(InFile) > 6 then
  begin
    BlockRead(InFile, Header, sizeof(Header));
    if Header.ID = 'LIB' then
    begin
      Writeln('LIB Format recognized');
      Writeln('# of files inside: ', Header.NrFiles);
    end
  end
  else
    CheckFile := False
end;

procedure ExtractFiles;
var
  FileTable: array[0..255] of TFileEntry;
  i, j     : Longint;
  OutFile  : file;
  CopyBuf  : array[0..10239] of Byte;

  function CompOffs(InOffs: array of Byte): Longint;
  begin
    CompOffs := Longint(InOffs[0]) +
                Longint(InOffs[1]) * 256 +
                Longint(InOffs[2]) * 65536
  end;

begin
  for i := 0 to Header.NrFiles do
    BlockRead(InFile, FileTable[i], sizeof(FileTable[i]));
  (* wir lesen NrFiles + 1, da der letzte Eintrag ein Leereintrag mit der
     Dateigre ist *)
  for i := 0 to Header.NrFiles - 1 do
  begin
    Write('Extracting ' + FileTable[i].FileName, ' @ ',
          CompOffs(FileTable[i].FileOffs), ' up to ',
          CompOffs(FileTable[i + 1].FileOffs), ' ... ');
    Assign(OutFile, FileTable[i].FileName);
    Rewrite(OutFile, 1);
    (* kopieren *)
    Seek(InFile, CompOffs(FileTable[i].FileOffs));
    for j := 1 to (CompOffs(FileTable[i + 1].FileOffs) -
                   CompOffs(FileTable[i].FileOffs)) div SizeOf(CopyBuf) do
    begin
      BlockRead(InFile, CopyBuf, SizeOf(CopyBuf));
      BlockWrite(OutFile, CopyBuf, SizeOf(CopyBuf))
    end;
    BlockRead(InFile, CopyBuf, (CompOffs(FileTable[i + 1].FileOffs) -
      CompOffs(FileTable[i].FileOffs)) mod SizeOf(CopyBuf));
    BlockWrite(OutFile, CopyBuf, (CompOffs(FileTable[i + 1].FileOffs) -
      CompOffs(FileTable[i].FileOffs)) mod SizeOf(CopyBuf));
    Close(OutFile);
    Writeln('finished')
  end
end;

begin
  Writeln('The Lost Files of Sherlock Holmes -- Case of The Serrated Scalpel');
  Writeln('Library extractor');
  Writeln('(C)opyright 2002, Deniz Oezmen');
  Writeln('early alpha, use at your own risk!');
  Writeln;
  if OpenFile then
  begin
    Writeln('Successfully opened ', ParamStr(1));
    if CheckFile then
      ExtractFiles
    else
      Writeln('Not a valid library.');
    Writeln('Closing file');
    Close(InFile)
  end
  else
    Writeln('Usage: LIBEXT <libfile>')
end.